#pragma once

class XTexture : public ITexture
{
	LPDIRECT3DTEXTURE8		m_lpTexture;	
	// information for restoring
	char					m_szFilePath[MAX_PATH];
	LPDIRECT3DDEVICE8		m_lpDevice;
	int						m_iMipLevels;
	D3DFORMAT				m_formatTextureFormat;
	// real dim of the created texture
	int						m_iWidth;
	int						m_iHeight;
	// references
	DWORD					m_dwRef;

public:
	virtual int						LoadTextureFromFile(LPCSTR szFileName);
	virtual int						LoadTextureFromFileEx(LPCSTR szFileName, int iMipLevels, D3DFORMAT formatTextureFormat);
	virtual int						Restore();
	virtual int						ReleaseResource();
	virtual LPDIRECT3DTEXTURE8		GetTexture() { return m_lpTexture; }
	virtual LPDIRECT3DDEVICE8		GetDevice() {return m_lpDevice; }
	virtual int						Width() {return m_iWidth;}
	virtual int						Height() {return m_iHeight;}
	// interface functions
	virtual HRESULT					AddRef();
	virtual HRESULT					Release();
public:
	XTexture(void);
	~XTexture(void);
};
