/*
 *
 * Interfaces.h - interfaces declarations
 *
 * Date:	10.6.2003
 * Update:	10.6. 2003
 * Author:	Jiri Formanek
 *
 */
#pragma once

class INPUT_API IInput
{
public:
	// Common func.
	virtual HRESULT Init(HINSTANCE hInst, HWND hWnd, D3DXVECTOR2* csResolution) = 0;
	virtual HRESULT	ProcessInput() = 0;
	//
	// Cursor function
	virtual HRESULT UpdateCursor() = 0;
	virtual void	ShowCursor(BOOL bShow = TRUE) = 0;
	virtual D3DXVECTOR2*	GetCursor() = 0;
	//
	// Detection
	virtual BOOL	IsRButtonDown(BOOL _Handling = TRUE) = 0;
	virtual BOOL	IsLButtonDown(BOOL _Handling = TRUE) = 0;
	virtual BOOL	IsRButtonUp() = 0;
	virtual BOOL	IsLButtonUp() = 0;
	virtual BOOL	IsKeyDown(int Key, BOOL bHandle = TRUE) = 0;

	virtual HRESULT RestoreDevices() = 0;	

	public:	
	// interface functions
	virtual HRESULT		AddRef() = 0;
	virtual HRESULT		Release() = 0;
};

class INPUT_API ICursor
{
public:
	virtual HRESULT		Create(LPCSTR csIntPath, int cx, int cy) = 0;
	virtual HRESULT		Create(LPCSTR csIntPath, int cx, int cy, int nSpeed, int iPhases) = 0;
	virtual HRESULT		Update(D3DXVECTOR2* ptCursor) = 0;

public:	
	// interface functions
	virtual HRESULT		AddRef() = 0;
	virtual HRESULT		Release() = 0;
};