unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, mmSystem, WaveUtils, WaveIO, WaveOut, WavePlayers,
  WaveIn, WaveRecorders, WaveStorage, Buttons, WaveRedirector, WaveTimer,
  ComCtrls;

type

  TForm1 = class(TForm)
    WaveStorage1: TWaveStorage;
    Redirector: TAudioRedirector;
    MultimediaTimer: TMultimediaTimer;
    WaveStorage2: TWaveStorage;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Button1: TButton;
    Recorder: TStockAudioRecorder;
    Player: TStockAudioPlayer;
    GroupBox4: TGroupBox;
    CheckBox5: TCheckBox;
    AudioLevel: TProgressBar;
    procedure RecorderActivate(Sender: TObject);
    procedure RecorderDeactivate(Sender: TObject);
    procedure RecorderPause(Sender: TObject);
    procedure RecorderResume(Sender: TObject);
    procedure PlayerActivate(Sender: TObject);
    procedure PlayerDeactivate(Sender: TObject);
    procedure PlayerPause(Sender: TObject);
    procedure PlayerResume(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure RedirectorActivate(Sender: TObject);
    procedure RedirectorDeactivate(Sender: TObject);
    procedure MultimediaTimerTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RedirectorAudioInLevel(Sender: TObject; Level: Integer);
    procedure FormCreate(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.RecorderActivate(Sender: TObject);
begin
  CheckBox1.Checked := True;
  MultimediaTimer.Enabled := True;
end;

procedure TForm1.RecorderDeactivate(Sender: TObject);
begin
  CheckBox1.Checked := False;
  MultimediaTimer.Enabled := Player.Active;
end;

procedure TForm1.RecorderPause(Sender: TObject);
begin
  CheckBox2.Checked := True;
end;

procedure TForm1.RecorderResume(Sender: TObject);
begin
  CheckBox2.Checked := False;
end;

procedure TForm1.PlayerActivate(Sender: TObject);
begin
  CheckBox3.Checked := True;
  MultimediaTimer.Enabled := True;
end;

procedure TForm1.PlayerDeactivate(Sender: TObject);
begin
  CheckBox3.Checked := False;
  MultimediaTimer.Enabled := Recorder.Active;
end;

procedure TForm1.PlayerPause(Sender: TObject);
begin
  CheckBox4.Checked := True;
end;

procedure TForm1.PlayerResume(Sender: TObject);
begin
  CheckBox4.Checked := False;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Recorder.Active := CheckBox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  Recorder.Paused := CheckBox2.Checked;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  Player.Active := CheckBox3.Checked;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  Player.Paused := CheckBox4.Checked;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
  Redirector.Active := CheckBox5.Checked;
end;

procedure TForm1.RedirectorActivate(Sender: TObject);
begin
  CheckBox5.Checked := True;
end;

procedure TForm1.RedirectorDeactivate(Sender: TObject);
begin
  CheckBox5.Checked := False;
end;

procedure TForm1.MultimediaTimerTimer(Sender: TObject);
begin
  if Recorder.Active then
    Label2.Caption := MS2Str(Recorder.Position, msHMSh);
  if Player.Active then
    Label4.Caption := MS2Str(Player.Position, msHMSh);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  WS: TCustomWaveStorage;
begin
  Recorder.Active := False;
  Player.Active := False;
  WS := Player.Stock;
  Player.Stock := Recorder.Stock;
  Recorder.Stock := WS;
end;

procedure TForm1.RedirectorAudioInLevel(Sender: TObject; Level: Integer);
begin
  AudioLevel.Position := Level;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // For Deplhi 6 and higher: can set the following event at designtime
  Redirector.AudioIn.OnLevel := RedirectorAudioInLevel;
end;

end.
