<?php
	///////////////////////////////////////////////////////////////////////////////
	// Copyright  2003 Michael Bird. All Rights Reserved                        //
	//                                                                           //
	// This file is part of Help Center Live.                                    //
	//                                                                           //
	// Help Center Live is free software; you can redistribute it and/or modify  //
	// it under the terms of the GNU General Public License as published by      //
	// the Free Software Foundation; either version 2 of the License, or         //
	// (at your option) any later version.                                       //
	//                                                                           //
	// Help Center Live is distributed in the hope that it will be useful,       //
	// but WITHOUT ANY WARRANTY; without even the implied warranty of            //
	// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             //
	// GNU General Public License for more details.                              //
	//                                                                           //
	// You should have received a copy of the GNU General Public License         //
	// along with Help Center Live; if not, write to the Free Software           //
	// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA //
	///////////////////////////////////////////////////////////////////////////////

		$HCL_version = "1.1";

		//-------------------
		// General config
		//-------------------

		// The name of your company. This will appear in the
		// title of any visable pages.
		$COMPANY_name = "Help Center Live";

		// The admin email of your company. This e-mail address
		// will be used in all automatic e-mails that are sent
		// from Help Center Live e.g. new registration e-mails
		$COMPANY_email = "sales@example.com";

		// The domain where Help Center Live is installed.
		// Include the sub-domain but do not include the trailing /
		$URL_site = "www.example.com";

		// The directory that the files are located in. Make sure
		// you include a / at the beginning and end of the
		// directory name. If it is in a sub domain just use one /
		$URL_dir = "/hcl/";

		// The full URL to the directory Help Center Live is in.
		// Make sure you do not include a trailing /
		$URL_maindir = "http://www.example.com/hcl";

		// If you are installing on an SSL site then change
		// this to 1 otherwise leave as 0
		$URL_secure = 0;

		// The offset time from GMT you want time signatures to appear
		// e.g "-6" will be Central Time: Mexico City and Central America
		// leave as "0" for GMT
		$TIME_offset = "0";

		// The language that will be used for the client side. Use the name
		// of the language file. e.g. if you are using spanishlang.php, in
		// the language setting put spannishlang
		$LANG_setting = "english";



		//-------------------
		// Database config
		//-------------------

		// The server your databse is on. This is usually localhost
		$DB_host = "localhost";

		// The username used to access your database
		$DB_user = "";

		// The password used for this username
		$DB_pass = "";

		// The name of the database Help Center Live is installed on
		$DB_name = "";

		// If you want to add a prefix to the table names. Otherwise
		// leave blank
		$DB_prefix = "";

		// If your database runs under a persistant connection.
		// Note leave this as 0 unless you know what you are doing.
		$DB_pconnect = 0;


		//------------------
		// Design config
		//------------------

		// Table header colour
		$TABLE_hcolour = "#C3C7CE";

		// Alternating row - dark colour
		$TABLE_dcolour = "#CFD2D8";

		// Alternating row - light colour
		$TABLE_lcolour = "#D9DBDF";


		//------------------
		// Live Help config
		//------------------

		// If you wish to monitor site traffic then this should
		// be left as 'yes' otherwise change to 'no'.
		$REQUEST_monitor_traffic = "yes";

		// In the message form you can send the message as an email
		// or a trouble ticket. If you want to send it as an email
		// then change this to 'email' otherwise leave as 'ticket'
		$MAIL_option = "ticket";

		// If you choose to use text status links then this prefix will
		// appear before 'ONLINE!' or 'Offline'
		// If it is a per department text link then this prefix will
		// appear before '[Department] ONLINE!' or '[Department] Offline'
		// e.g. Live Support ONLINE!  or  Live Support [Help] Offline
		$LIVE_text = "Live Support";


		// This is the format in which you want the operators messages
		// to appear. for example
		// $CHAT_opauthor = "first_last_dep";
		// will output..
		// 12.00 John Smith [Department]: Hi there how may I help you

		// $CHAT_opauthor = "user";
		$CHAT_opauthor = "first";
		// $CHAT_opauthor = "first_last";
		// $CHAT_opauthor = "first_last_dep";
		// $CHAT_opauthor = "first_dep";


		// Pixels width of traffic monitor window
		$REQUEST_width = "400";

		// Pixels height of traffic monitor window
		$REQUEST_height = "300";

		// Pixels width of operator chat window
		$CHAT_o_width = "400";

		// Pixels height of operator chat window
		$CHAT_o_height = "600";

		// Pixels width of guest chat window
		$CHAT_g_width = "400";

		// Pixels height of guest chat window
		$CHAT_g_height = "400";

		// The number of seconds the operator has to accept chat before
		// it polls to next operator
		$SESSION_timeout = "15";

		// The number of miliseconds to refresh the tracker.
		// This checks for initiated chat requests and updates the
		// visitors timer so they do not reamin idle and timeout
		$TRACKER_refresh = "10000";

		// The number of seconds the visitor can remain idle until
		// they timeout.
		$TRAFFIC_timeout = "30";

		// The number of seconds the visitor can remain idle until
		// their total time on site updates as a new visit.
		// Note that if this is different to $TRAFFIC_timeout and the
		// user revisits a page after between the $TRAFFIC_timeout
		// and $TRAFFIC_newvisit period the traffic monitor will not
		// refresh to show the visitor again.
		$TRAFFIC_newvisit = "30";

		// The number of miliseconds to refresh the chat window to check
		// for new chat messages recommended is 3000 to 5000
		$CHAT_refresh = "5000";

		// The number of seconds until the chat session times out
		$CHAT_timeout = "25";

		// The number of miliseconds to refresh the chat window to check
		// for any new visitors or chat requests recommended is 3000 to 5000
		$REQUEST_refresh = "5000";

		// The number of seconds the operator can remain idle until
		// their status changes to offline
		$LIVE_timeout = "15";



		//-------------------
		// Other Config
		//-------------------

		// Do not change the lines below, they are used to
		// make sure the script runs correctly.

		// Date in the past
		header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

		// Always modified
		header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");

		// HTTP/1.1
		header("Cache-Control: no-store, no-cache, must-revalidate");
		header("Cache-Control: post-check=0, pre-check=0", false);

		// HTTP/1.0
		header("Pragma: no-cache");

		// Error reporting
		error_reporting (E_ALL ^ E_NOTICE);


?>