unit mainModule;

interface

uses
  SysUtils, Classes, HTTPApp;

type
  TWebModule1 = class(TWebModule)
    procedure WebModule1WebActionItem1Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WebModule1: TWebModule1;

implementation

{$R *.dfm}

procedure TWebModule1.WebModule1WebActionItem1Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
if Request.Method = 'GET' then
begin
//This is where we define the output for the form- once the form is submitted,
//the POST method is called and our output is defined by the "else" clause.
response.content := '<html><head><title>Learning ISAPI</title></head><h3>Learning ISAPI!</h3>'
+ '<form name="isapiform" method="POST" action="' + request.URL + '">'
+ '<strong>Please enter the following information</strong><br>'
+ 'Name: <input type="text" name="name"><br>'
+ '<input type="checkbox" name="likes" value="true" checked> I like ISAPI!<p>'
+ '<input type="submit" value="View Output"></form></html>';
//The above defines the output. It outputs a form prompting for the user's name
//and asks whether they like ISAPI. Request.url is a method we can use to find the
//URL of the page. We use this as our "action" because the same function as this will
//handle the form. (see below)
end
else
begin
//This is where we handle our form and output the submitted information
//First, we'll check to see if the "NAME" field isn't blank, if it is, we'll output
//a message stating that it was required.
if request.contentfields.values['name'] = '' then
response.content := '<html><head><title>Error!</title></head><h3>Error!</h3><p>The name field is required!<br>'
+ '<a href="javascript:history.go(-1);">Back</a>';
//If there was no error, response.content still equals '', so we proceed through the rest by
//checking if response.content equals ''
if response.content = '' then
begin
response.content := '<html><head><title>Congratulations</title></head><h3>Congratulations</h3><hr>'
+ 'The form resulted in the following information:<br>'
+ 'Your name is ' + request.contentfields.values['name'] + '.<br>';
//If they stated they like ISAPI, output a "thank you", otherwise output an "I'm sorry!"
if request.contentfields.values['likes'] = 'true' then
response.content := response.content + 'Thank you! You like ISAPI!'
else
response.content := response.content + 'I''m very sorry that you don''t like ISAPI!';
response.content := response.content + '</html>';
end;
end;
end;

end.
