program p2p_rcv;

{$APPTYPE CONSOLE}

uses
  sysutils,
  jmsIntf,
  jmsException,
  jmsSonicMQ,
  apiSonicMQ;

var
  factory : IQueueConnectionFactory;
  qConnection : IQueueConnection;
  qSession : IQueueSession;
  queue : IQueue;
  receiver : IQueueReceiver;

  msg : IMessage;
  msgText : ITextMessage;

  str : string;

begin
  try
    factory := TSMQQueueConnectionFactory.Create('tcp://localhost:2506');
    qConnection := factory.createQueueConnection;
    qConnection.start;

    writeln ('Connect successfully start');

    qSession := qConnection.createQueueSession(false, Session_AUTO_ACKNOWLEDGE);

    queue := qSession.createQueue('SampleQ1');

    receiver := qSession.createReceiver(queue);

    writeln ('Receiver successfully created');

    repeat
      writeln ('Wait for message again 30 sec...');

      msg := receiver.receive (30*1000);
      if Assigned (msg) then
      begin
        try
          msgText := msg as ITextMessage;
          Writeln ('Receive Text message: ', msgText.Text);
        except
          Writeln ('Receive unsupported JMS message type');
        end;
      end
      else
      begin
        writeln ('Wait for message again?');
        write ('Hit Enter for terminate programm or type Y then hit Enter for wait: ');
        readln (str);
        if str = '' then break;
      end;
    until false;
  except
    on E : EJMSException do
    begin
      writeln ('JMS Error: ', E.Message, ' JMS EC=', E.ErrorCode);
      write ('Press ENTER to terminate programm');
      readln;
    end;
    on E : Exception do
    begin
      writeln ('Error: ', E.Message);
      write ('Press ENTER to terminate programm');
      readln;
    end;
  end;
end.
