program p2p_send;

{$APPTYPE CONSOLE}

uses
  sysutils,
  jmsIntf,
  jmsException,
  jmsSonicMQ,
  apiSonicMQ;

var
  factory : IQueueConnectionFactory;
  qConnection : IQueueConnection;
  qSession : IQueueSession;
  queue : IQueue;
  sender : IQueueSender;

  msg : ITextMessage;

  str : string;

begin
  try
    factory := TSMQQueueConnectionFactory.Create('tcp://localhost:2506');
    qConnection := factory.createQueueConnection;
    qConnection.start;

    writeln ('Connect successfully start');

    qSession := qConnection.createQueueSession(false, Session_AUTO_ACKNOWLEDGE);

    queue := qSession.createQueue('SampleQ1');

    sender := qSession.createSender(queue);

    writeln ('Sender successfully created');

    Writeln ('Type text message and press ENTER to send it.');
    Writeln ('Or simply press ENTER to exit from programm');

    repeat
      Readln (str);
      if str = '' then break;

      msg := qSession.createTextMessage;

      msg.Text := str;

      sender.send(msg);

      writeln ('Message successfully send. Wait for next command...');
    until false;
  except
    on E : EJMSException do
    begin
      writeln ('JMS Error: ', E.Message, ' JMS EC=', E.ErrorCode);
      write ('Press ENTER to terminate programm');
      readln;
    end;
    on E : Exception do
    begin
      writeln ('Error: ', E.Message);
      write ('Press ENTER to terminate programm');
      readln;
    end;
  end;
end.
