<?php # $Id: index.php,v 1.27 2003/09/18 12:57:46 garvinhicking Exp $

// We need to set this to return a 200 since we use .htaccess ErrorDocument
// rules to handle archives.
header('HTTP/1.0 200\r\n');
include_once('serendipity_config.inc.php');
$track_referer = true;
$uri = $_SERVER['REQUEST_URI'];

if (preg_match('@/unsubscribe/(.*)/([0-9]+)@', $uri, $res)) {
    serendipity_cancelSubscription(urldecode($res[1]), $res[2]);
    $uri = '/archives/'. $res[2] .'_untitled.html';
}

if (preg_match('@/archives/(\d+)\.html@', $uri, $matches)) {
    header('Content-Type: text/html; charset=ISO-8859-1');
    $range                             = $matches[1];
    $_GET['serendipity']['action']     = 'read';
    $_GET['serendipity']['range']      = $range;
    $_GET['serendipity']['hidefooter'] = true;

    if (strlen($range) == 6) {
        $date = date('m/Y', mktime(0, 0, 0, substr($range, 4, 6), 2, substr($range, 0, 4)));
    } else {
        $date = date('d/m/Y', strtotime($range));
    }

    $serendipity['blogSubTitle'] = sprintf(ENTRIES_FOR, $date);
    ob_start();
    include_once('serendipity_genpage.inc.php');
    $data = ob_get_contents();
    ob_end_clean();

    if (isset($serendipity['pregenerate']) && $serendipity['pregenerate']) {
        $fp = fopen('./archives/' . $matches[1], 'w');
        fwrite($fp, $data);
        fclose($fp);
    }

    echo $data;
} else if (preg_match('@/archives/(\d+)_short\.html@', $uri, $matches)) {
    header('Content-Type: text/html; charset=ISO-8859-1');
    $range = $matches[1];
    $_GET['serendipity']['action'] = 'read';
    $_GET['serendipity']['range']  = $range;
    $_GET['serendipity']['short']  = true;

    if (strlen($range) == 6) {
        $date = date('m/Y', mktime(0,0,0, substr($range, 4, 6), 2, substr($range, 0, 4)));
    } else {
        $date = date('d/m/Y', strtotime($range));
    }

    $serendipity['blogSubTitle'] = sprintf(ENTRIES_FOR, $date);
    ob_start();
    include_once('serendipity_genpage.inc.php');
    $data = ob_get_contents();
    ob_end_clean();

    if (isset($serendipity['pregenerate']) && $serendipity['pregenerate']) {
        $fp = fopen('./archives/' . $matches[1], 'w');
        fwrite($fp, $data);
        fclose($fp);
    }

    echo $data;
} else if (preg_match('@/(\d+)_\w*\.html@i', $uri, $matches)) {
    header('Content-Type: text/html; charset=ISO-8859-1');
    $id = $matches[1];

    serendipity_track_referrer($id);
    $track_referer = false;

    $_GET['serendipity']['action'] = 'read';
    $_GET['serendipity']['id']     = $id;

    $title = serendipity_db_query("SELECT title FROM {$serendipity['dbPrefix']}entries " .
                                 'WHERE id=' . serendipity_db_escape_string($id), true);
    $title = $title[0];

    $serendipity['blogTitle'] = htmlspecialchars($title);

    ob_start();
    include_once('serendipity_genpage.inc.php');
    $data = ob_get_contents();
    ob_end_clean();

    if (isset($serendipity['pregenerate']) && $serendipity['pregenerate']) {
        $fp = fopen('./archives/' . $matches[1], 'w');
        fwrite($fp, $data);
        fclose($fp);
    }
    print $data;
} else if (preg_match('@/feeds/@', $uri)) {
    header('Content-Type: text/html; charset=utf-8');
    if (preg_match('@/index.(rss|rdf|rss2)$@', $uri, $matches)) {
        switch ($matches[1]) {
        case 'rss':
            $_GET['version'] = '0.91';
            break;
        case 'rss2':
            $_GET['version'] = '2.0';
            break;
        }

        ob_start();
        include_once('rss.php');
        $data = ob_get_contents();
        ob_end_clean();

        $data = ltrim($data);

        if ($serendipity['pregenerate']) {
            $fp = fopen('./feeds/index.' . $matches[1], 'w');
            fwrite($fp, $data);
            fclose($fp);
        }

        print $data;
        exit;
    }
} else if (preg_match('@/admin$@', $uri)) {
    header("Location: {$serendipity['serendipityHTTPPath']}serendipity_admin.php");
    exit;
} else if (preg_match('@/entries$@', $uri)) {
    header("Location: {$serendipity['serendipityHTTPPath']}serendipity_entries.php");
    exit;
} else if (preg_match('@/archive$@', $uri)) {
    header('Content-Type: text/html; charset=ISO-8859-1');
    $serendipity['GET']['action'] = 'archives';
    include_once('serendipity_genpage.inc.php');
} else if (preg_match('@/categories/(.*)@', $uri, $matches) ||
           preg_match('@/(index\.(php|html))?@', $uri) ||
           preg_match('@/(' . preg_quote($serendipity['indexFile']) . ')?@', $uri)) {

    header('Content-Type: text/html; charset=ISO-8859-1');

    if (count($serendipity['GET']) == 2) {
        if (isset($matches) && is_array($matches) && isset($matches[1])) {
            $serendipity['GET']['category'] = $matches[1];
        }

        ob_start();
        include_once('serendipity_genpage.inc.php');
        $data = ob_get_contents();
        ob_end_clean();
        if (isset($serendipity['pregenerate']) && $serendipity['pregenerate']) {
            $fp = fopen('./index.html', 'w');
            fwrite($fp, $data);
            fclose($fp);
        }
        print $data;
    } else {
        if (isset($matches) && is_array($matches) && isset($matches[1])) {
            $serendipity['GET']['category'] = $matches[1];
        }

        if (isset($serendipity['GET']['calendarZoom'])) {
            $serendipity['GET']['action'] = 'read';
            $serendipity['GET']['range'] = $serendipity['GET']['calendarZoom'];
        }
        include_once('serendipity_genpage.inc.php');
    }
} else {
    printf(DOCUMENT_NOT_FOUND, $uri);
}

if ($track_referer) {
    serendipity_track_referrer();
}
/* vim: set sts=4 ts=4 expandtab : */
?>
