<?php # $Id: serendipity_plugin_comments.php,v 1.9 2003/11/06 15:52:29 jtate Exp $

class serendipity_plugin_comments extends serendipity_plugin
{
    function introspect(&$propbag)
    {
        global $serendipity;
        
        $propbag->add('name',          COMMENTS);
        $propbag->add('description',   'Displays the last comments to your entries');
        
        $propbag->add('configuration', array(
                                             'wordwrap',
                                             'max_chars',
                                             'max_entries',
                                             'language',
                                             'dateformat'));
    }

    function introspect_config_item($name, &$propbag)
    {
        switch($name) {
            case 'wordwrap':
                $propbag->add('type', 'string');
                $propbag->add('name', 'Wordwrap');
                $propbag->add('description', 'How many words until a wordwrap will occur? (Default: 30)');
                break;

            case 'max_chars':
                $propbag->add('type', 'string');
                $propbag->add('name', 'Maximum chars per comment');
                $propbag->add('description', 'How many chars will be displayed for each comment? (Default: 120)');
                break;

            case 'max_entries':
                $propbag->add('type', 'string');
                $propbag->add('name', 'Maximum number of comments');
                $propbag->add('description', 'How many comments will be shown? (Default: 15)');
                break;

            case 'language':
                $propbag->add('type', 'string');
                $propbag->add('name', 'Output language');
                $propbag->add('description', 'What is your output language? ("en|de", default "en")');
                break;

            case 'dateformat':
                $propbag->add('type', 'string');
                $propbag->add('name', 'Dateformatting');
                $propbag->add('description', 'The format of the actual Date, using PHPs strftime() variables. (Default: "%a, %m.%m.%Y %H:%M")');
                break;

            default:
                    return false;
        }
        return true;
    }

    function generate_content(&$title)
    {
        global $serendipity;
        $title       = COMMENTS;
        $lang        = strtolower($this->get_config('language'));
        $max_entries = $this->get_config('max_entries');
        $max_chars   = $this->get_config('max_chars');
        $wordwrap    = $this->get_config('wordwrap');
        $dateformat = $this->get_config('dateformat');
        
        if (!$max_entries || !is_numeric($max_entries) || $max_entries < 1) {
            $max_entries = 15;
        }
        
        if (!$max_chars || !is_numeric($max_chars) || $max_chars < 1) {
            $max_chars = 120;
        }
        
        if (!$wordwrap || !is_numeric($wordwrap) || $wordwrap < 1) {
            $wordwrap = 30;
        }
        
        if (!$dateformat || strlen($dateformat) < 1) {
            $dateformat = '%a, %d.%m.%Y %H:%M';
        }

        if ($lang != 'de' && $lang != 'en') {
            $lang = 'en';
        }
        
        switch($lang) {
            case 'de':
                    $loc = setlocale(LC_ALL, 'de');
                    $out = '%s zu%s';
                break;
            
            case 'en':
                    $loc = setlocale(LC_ALL, 'en');
                    $out = '%s about%s';
                break;
        }

        $q = 'SELECT    c.body              AS comment,
                        c.timestamp         AS stamp,
                        c.author            AS user,
                        e.title             AS subject,
                        e.id                AS entry_id,
                        c.id                AS comment_id
                FROM    '.$serendipity['dbPrefix'].'comments AS c,
                        '.$serendipity['dbPrefix'].'entries  AS e
               WHERE    e.id = c.entry_id
            ORDER BY    c.timestamp DESC
            LIMIT ' . $max_entries;
?>
<div style="margin: 0px; padding: 0px; text-align: left;">
<?php
        $sql = serendipity_db_query($q);
        
        if ($sql && is_array($sql)) {
            foreach($sql AS $key => $row) {
                $comments = wordwrap(strip_tags($row['comment']), $max_chars, '@@@', 1);
                $aComment = explode('@@@', $comments);
                $comment  = $aComment[0];
                if (count($aComment) > 1) {
                    $commentar .= ' [...]';
                }
        
                printf(
                  $out,
                  htmlentities($row['user']),
                  ' <a class="highlight" href="' . serendipity_archiveURL($row['entry_id'], $row['subject']) .'" title="' . htmlentities($row['subject']) . '">'
                      . htmlentities($row['subject'])
                      . '</a><br />' . "\n"
                      . htmlentities(strftime($dateformat, $row['stamp'])) . '<br />' . "\n"
                      . serendipity_emoticate(serendipity_markup_text(wordwrap(htmlentities($comment), $wordwrap, "<br />\n", 1)))
                      . '<br /><br /><br />' . "\n\n"
                );
            }
        }
?>
</div>
<?php
    }
}

/* vim: set sts=4 ts=4 expandtab : */
?>
