<?php # $Id: serendipity_plugin_content_rewrite.php,v 1.2 2003/08/02 15:43:22 garvinhicking Exp $

class serendipity_plugin_content_rewrite extends serendipity_plugin
{
var $rewrite_from, $rewrite_to;

    function introspect(&$propbag)
    {
        global $serendipity;
        
        $propbag->add('name',          'Content-Rewriter');
        $propbag->add('description',   'Replaces any word with a new string (like for Acronyms)');
        
        // Cleanup. Remove all empty configs on SAVECONF-Submit.
        // TODO: Maybe this cleanup can be done in a more 'beautiful' way,
        //       but this would need an update to the
        //       serendipity_admin_plugins.inc.php scripts and then affect
        //       every plugin.
        if ($_POST['SAVECONF']) {
            $rows = serendipity_db_query("DELETE
                                            FROM  {$serendipity['dbPrefix']}config
                                           WHERE  (name LIKE '" . $this->instance . "/title_%' AND value = '')
                                              OR  (name LIKE '" . $this->instance . "/description_%' AND value = '')");
        }
        
        $rows = serendipity_db_query("SELECT name, value FROM {$serendipity['dbPrefix']}config WHERE name LIKE '" . $this->instance . "/%'");

        $counter = 0;
        $values  = array();
        $values[] = 'title';
        $values[] = 'rewrite_string';
        $values[] = 'rewrite_char';

        if (is_array($rows)) {
            foreach ($rows as $row) {
                $plugin_value = str_replace($this->instance . '/', '', $row['name']);
                preg_match('|^(.*)_([0-9]*)$|msU', $plugin_value, $reg_counter);

                $found = false;
                if ($reg_counter[1] == 'title') {
                    $title_values[] = $plugin_value;
                    $found = true;
                } elseif ($reg_counter[1] == 'description') {
                    $descr_values[] = $plugin_value;
                    $found = true;
                }
                
                if ($found) {
                    $next_counter = $reg_counter[2] + 1;
                    $counter      = ($next_counter > $counter ? $next_counter : $counter);
                }
            }
        }
        
        $counter        = ($counter > 0 ? $counter + 1 : $counter);
        $title_values[] = 'title'       . '_' . $counter;
        $descr_values[] = 'description' . '_' . $counter;

        if (is_array($title_values) && is_array($descr_values) && count($title_values) == count($descr_values)) {
            foreach($title_values AS $key => $val) {
                $values[] = $title_values[$key];
                $values[] = $descr_values[$key];
            }
        }
        
        $propbag->add('configuration', $values);

        // Static values: All the values gathered for replacements
        $propbag->add('rewrite_active', true);
        $propbag->add('rewrite_from'  , $title_values);
        $propbag->add('rewrite_to'    , $descr_values);

        $this->counter = $counter;
    }

    function introspect_config_item($name, &$propbag)
    {
        preg_match('|^(.*)_([0-9]*)$|msU', $name, $switch);
        
        if (!isset($switch[2])) {
            $switch[1] = $name;
            $switch[2] = 'empty';
        }
        
        switch($switch[1]) {
            case 'title':
            
                    if ($switch[2] != 'empty') {
                        $propbag->add('type',        'string');
                        
                        if ($this->counter == $switch[2]) {
                            $propbag->add('name',        'New Title');
                            $propbag->add('description', 'Enter the acronym-title for a new item here ({from})');
                        } else {
                            $propbag->add('name',        'Title #' . $switch[2]);
                            $propbag->add('description', 'Enter the acronym here ({from})');
                        }
                    } else {
                        $propbag->add('type',        'string');
                        $propbag->add('name',        'Plugin-Title');
                        $propbag->add('description', 'The name of this plugin');
                    }
                    break;

            case 'description':
                    $propbag->add('type',        'string');

                    if ($this->counter == $switch[2]) {
                        $propbag->add('name',        'New Description');
                        $propbag->add('description', 'Enter the description for a new item here ({to})');
                    } else {
                        $propbag->add('name',        'Description #' . $switch[2]);
                        $propbag->add('description', 'Enter the description here ({to})');
                    }
                    break;

            case 'rewrite_string':
                    $propbag->add('type',         'string');
                    $propbag->add('name',         'Rewrite string');
                    $propbag->add('description',  'The string used to rewrite. Place {from} and {to} anywhere you like to get a rewrite.' . "\n" . 'Example: <acronym title="{to}">{from}</acronym>');
                    break;

            case 'rewrite_char':
                    $propbag->add('type',         'string');
                    $propbag->add('name',         'Rewrite char');
                    $propbag->add('description',  'If there is any char you append to force rewriting, enter it here. If you want to only replace \'serendipity*\' with what you entered for that word but want the \'*\' removed, enter that char here. NOTE: You can\'t use a different rewrite_char for a plugin having the same rewrite_string!');
                    break;

            default:
                    return false;
        }
        return true;
    }

    function generate_content(&$title)
    {
        $bag = new serendipity_property_bag;
        $return = $this->introspect($bag);
        $to   = &$bag->get('rewrite_to');
        $from = &$bag->get('rewrite_from');
        $title = $this->get_config('title');
?>
<table>
<?php
        foreach($from AS $key => $val) {
?>
    <tr>
        <th style="font-size: 8pt; font-color: white;"><?= htmlentities($this->get_config($val)); ?></th>
        <td><?= htmlentities($this->get_config($to[$key])); ?></td>
    </tr>
<?php
        }
?>
</table>
<?php
    }
}

/* vim: set sts=4 ts=4 expandtab : */
?>
