<?php # $Id: serendipity_admin_installer.inc.php,v 1.46 2003/11/11 16:17:04 garvinhicking Exp $

umask(0000);
$umask = 0770;
define('IN_installer', true);
include_once('serendipity_config.inc.php');
function serendipity_query_default($optname, $default)
{
    switch ($optname) {
        case 'serendipityPath':
            return dirname(__FILE__) .'/';

        case 'serendipityHTTPPath':
            return rtrim(dirname($_SERVER['PHP_SELF']), '/') .'/';

        case 'baseURL':
            $ssl  = isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on';
            $port = $_SERVER['SERVER_PORT'];

            return sprintf('http%s://%s%s%s',

                            $ssl ? 's' : '',
                            $_SERVER['HTTP_HOST'],
                            (($ssl && $port != 443) || (!$ssl && $port != 80)) ? (':' . $port) : '',
                            rtrim(dirname($_SERVER['PHP_SELF']), '/') .'/'
                   );

        case 'convert':
            if (isset($_EVN['PATH'])) {
                $path = explode(':', $_ENV['PATH']);
            } else {
                $path = '';
            }

            /* add some other possible locations to the path while we are at it,
             * as these are not always included in the apache path */
            $path[] = '/usr/X11R6/bin';
            $path[] = '/usr/bin';

            foreach ($path as $dir) {
                if (function_exists('is_executable') && is_executable($dir . '/convert') || is_file($dir . '/convert')) {
                    return $dir . '/convert';
                }
            }
            return $default;

        default:
            return $default;
    }
}

function serendipity_parseTemplate($n, $raw = false) {
    global $serendipity;
    $config = array();

    $t = file($n);
    for ($x=0; $x<count($t); $x++) {
        $l = $t[$x];
        $l = trim($l);

        if ($l != '') {
            switch ($l[0]) {

                // New Configure section
                case '/':
                    if ($l[1] == '/') {
                        $current = trim(substr($l, 2));
                        $config['categories'][$current] = array();
                    }
                    break;

                case '#':
                    $config['descriptions'][$current] =  trim(substr($l, 1));
                    break;

                // A configure option
                case '$':
                    // Grep out the name, type and default
                    preg_match('#\{([^|]+\|[^|]+\|([^}]+)?)\}[^/]+/{2}(.+)#msi', $l, $match);
                    $c    = explode('|', $match[1]);
                    $cdef = serendipity_query_default($c[1], $c[3]);
                    $config['categories'][$current][] = $configRaw[] = array(
                                            'longname'    => $c[0],
                                            'name'        => $c[1],
                                            'type'        => $c[2],
                                            'default'     => $cdef,
                                            'distdefault' => $c[3],
                                            'desc'        => $match[3]
                                          );
                    break;
            }
        }
    }

    if ($raw) {
        return $configRaw;
    } else {
        return $config;
    }
}

function serendipity_guessInput($type, $name, $value='', $default='') {
    switch ($type) {
        case 'bool' :
            echo '<input id="radio_cfg_' . $name . '_yes" type="radio" name="' . $name . '" value="true" ';
            echo (($default == true) ? 'checked="checked"' : ''). ' /><label for="radio_cfg_' . $name . '_yes"> ' . YES . '</label>&nbsp;';
            echo '<input id="radio_cfg_' . $name . '_yes" type="radio" name="' . $name . '" value="false" ';
            echo (($default == true) ? '' : 'checked="checked"'). ' /><label for="radio_cfg_' . $name . '_yes"> ' . NO . '</label>';
            break;

        case 'protected' :
            echo '<input type="password" size="30" name="' . $name . '" value="' . htmlentities($default) . '" />';
            break;

        default :
            echo '<input type="text" size="30" name="' . $name . '" value="' . htmlentities($default) . '" />';
            break;
    }
}

function serendipity_printConfigTemplate($t, $from = false) {
    global $serendipity;
?>
<script type="text/javascript" language="JavaScript">
function showConfig(id) {
    if (document.getElementById) {
        el = document.getElementById(id);
        if (el.style.display == 'none') {
            document.getElementById('option' + id).src = 'pixel/minus.png';
            el.style.display = '';
        } else {
            document.getElementById('option' + id).src = 'pixel/plus.png';
            el.style.display = 'none';
        }
    }
}

var state='';
function showConfigAll(count) {
    if (document.getElementById) {
        for (i = 1; i <= count; i++) {
            document.getElementById('el' + i).style.display = state;
            document.getElementById('optionel' + i).src = 'pixel/' + (state == '' ? 'minus.png' : 'plus.png');
        }

        if (state == '') {
            document.getElementById('optionall').src = 'pixel/minus.png';
            state = 'none';
        } else {
            document.getElementById('optionall').src = 'pixel/plus.png';
            state = '';
        }
    }
}
</script>

<form action="?" method="POST">
    <div>
        <input type="hidden" name="serendipity[adminModule]" value="installer" />
        <input type="hidden" name="installAction" value="check" />
        <br />
        <div align="right">
            <a style="border:0; text-decoration: none" href="#" onclick="showConfigAll(<?php echo count($t['categories']); ?>)" title="<?php echo TOGGLE_ALL; ?>"><img src="pixel/plus.png" id="optionall" alt="+/-" border="0" />&nbsp;<?php echo TOGGLE_ALL; ?></a></a><br />
        </div>
<?php
    $el_count = 0;
    foreach ($t['categories'] as $key => $value) {
        $el_count++;
?>
        <table width="100%" cellspacing="2">
            <tr>
                <th align="left" colspan="2" style="padding-left: 15px;">
                    <a style="border:0; text-decoration: none" href="#" onclick="showConfig('el<?php echo $el_count; ?>'); return false" title="<?php echo TOGGLE_OPTION; ?>"><img src="pixel/plus.png" id="optionel<?php echo $el_count; ?>" alt="+/-" border="0" />&nbsp;<?php echo $key; ?></a></th>
            </tr>

            <tr>
                <td>
                    <table width="100%" cellspacing="0" cellpadding="3" style="<?php echo (IS_installed === true ? 'display: none;' : ''); ?>" id="el<?php echo $el_count; ?>">
                        <tr>
                            <td style="padding-left: 20px;" colspan="2">
                                <?php echo $t['descriptions'][$key] ?>
                            </td>
                        </tr>


<?php
        for ($x=0; $x<count($value); $x++) {
            if (@is_array($from)) {
                $value[$x]['default'] = $from[$value[$x]['name']];
            }
?>
                        <tr>
                            <td style="border-bottom: 1px #000000 solid" align="left" valign="top" width="75%">
                                <strong><?php echo $value[$x]['longname']; ?></strong>
                                <br />
                                <span style="color: #5E7A94; font-size: 8pt;"><?php echo '(' . $value[$x]['type'] . ') ' . $value[$x]['desc']; ?></span>
                            </td>

                            <td style="border-bottom: 1px #000000 solid; font-size: 8pt" align="left" valign="middle" width="25%">
                                <?php echo ($serendipity['XHTML11'] ? '<span style="white-space: nowrap">' : '<nobr>'); ?><?php echo serendipity_guessInput($value[$x]['type'], $value[$x]['name'], $from[$value[$x]['name']], $value[$x]['default']); ?><?php echo ($serendipity['XHTML11'] ? '</span>' : '</nobr>'); ?>
                            </td>
                        </tr>
<?php
        }
?>
                    </table><br /><br />
                </td>
            </tr>
        </table>
<?php
    }
?>
        <input type="submit" value="<?php echo CHECK_N_SAVE; ?>" />
    </div>
</form>
<?php
}

function serendipity_parse_sql_tables($filename) {
    $in_table = 0;
    $queries = array();

    $fp = fopen($filename, 'r');
    while (!@feof($fp)) {
        $line = trim(fgets($fp, 4096));
        if ($in_table) {
            $def .= $line;
            if (preg_match('/^\)\s*(type\=\S+)?\s*\;$/i', $line)) {
                $in_table = 0;
                array_push($queries, $def);
            }
        } else {
            if (preg_match('#^create table \{PREFIX\}\S+\s*\(#i', $line)) {
                $in_table = 1;
                $def = $line;
            }

            if (preg_match('#^create\s*(\{fulltext\}|unique)\s*index#i', $line)) {
                array_push($queries, $line);
            }
        }
    }
    fclose($fp);

    return $queries;
}

function serendipity_checkInstallation() {
    global $serendipity, $umask;

    // Check dirs
    if ( !is_dir($_POST['serendipityPath']) ) {
        $errs[] = sprintf(DIRECTORY_NON_EXISTANT, $_POST['serendipityPath']);
    }
    elseif ( !is_writable($_POST['serendipityPath']) ) {
        $errs[] = sprintf(DIRECTORY_WRITE_ERROR, $_POST['serendipityPath']);
    }
    elseif ( !is_dir($_POST['serendipityPath'] . $_POST['uploadPath'] ) && @mkdir($_POST['serendipityPath'] . $_POST['uploadPath'], $umask) !== true) {
        $errs[] = sprintf(DIRECTORY_CREATE_ERROR, $_POST['serendipityPath'] . $_POST['uploadPath']);
    }
    elseif ( !is_writable($_POST['serendipityPath'] . $_POST['uploadPath']) ) {
        $errs[] = sprintf(DIRECTORY_WRITE_ERROR, $_POST['serendipityPath'] . $_POST['uploadPath']);
        $errs[] = sprintf(DIRECTORY_RUN_CMD    , 'chmod g+rws', $_POST['serendipityPath'] . $_POST['uploadPath']);
    }

    // Attempt to create the archives directory
    if ( !is_dir($_POST['serendipityPath'] . 'archives') && @mkdir($_POST['serendipityPath'] . 'archives', $umask) !== true ) {
        $errs[] = sprintf(DIRECTORY_CREATE_ERROR, $_POST['serendipityPath'] . 'archives');
        $errs[] = sprintf(DIRECTORY_RUN_CMD     , 'mkdir'      , $_POST['serendipityPath'] . 'archives');
        $errs[] = sprintf(DIRECTORY_RUN_CMD     , 'chmod g+rwx', $_POST['serendipityPath'] . 'archives');
    }

    // plugins directory now part of basic CVS

    // Check imagick
    if ($_POST['magick'] == 'true' && !is_executable($_POST['convert'])) {
        $errs[] = sprintf(CANT_EXECUTE_BINARY, 'convert imagemagick');
    }

    $serendipity['dbType'] = $_POST['dbType'];
    // Probe database
    // (do it after the dir stuff, as we need to be able to create the sqlite database)
    if ( @include_once($_POST['serendipityPath'] . '/serendipity_db.inc.php') ) {
        serendipity_db_probe($_POST, $errs);
    }
    return $errs;
}

function serendipity_installDatabase() {
    global $serendipity;

    /* Try and check if the database/tables are already installed,
       if they are... exit the function */
    echo CHECK_DATABASE_EXISTS;
    $t = serendipity_db_query("SELECT * FROM {$_POST['dbPrefix']}authors");
    echo ' ' . DONE . '<br />';
    if (is_array($t)) {
        return false;
    }

    echo CREATE_DATABASE;
    // Create tables
    $queries = serendipity_parse_sql_tables('./db.sql');
    $queries = str_replace('{PREFIX}', $_POST['dbPrefix'], $queries);

    foreach ($queries as $query) {
        serendipity_db_schema_import($query);
    }

    if($_POST['want_mail'] == true) {
        $mail_comments = 1;
    } else {
        $mail_comments = 0;
    }
    echo ' ' . DONE . '<br />';

    /*
        ------------- Install main author ------------
    */
    $enc_pass = md5($_POST['pass']);
    $query = "INSERT INTO {$_POST['dbPrefix']}authors (
                            username,
                            password,
                            email,
                            mail_comments
                          )
                  VALUES  (
                            '{$_POST['user']}',
                            '$enc_pass',
                            '{$_POST['email']}',
                            $mail_comments
                          )";
    serendipity_db_query($query);

    include_once $_POST['serendipityPath'] . '/serendipity_functions_config.inc.php';

    $serendipity['dbPrefix'] = $_POST['dbPrefix'];
    serendipity_set_config_var('template', 'default');

    $text = serendipity_db_escape_string(file_get_contents('./serendipity.css'));
    $query = "INSERT into {$_POST['dbPrefix']}css (name, data) values ('default', '$text')";
    return serendipity_db_query($query);
}

function serendipity_installFiles() {
    $a = file('./htaccess.tpl');
    $fp = @fopen('./.htaccess', 'w');

    $content = str_replace(
                 array(
                   '{PREFIX}',
                   '{indexFile}'
                 ),

                 array(
                   $_POST['serendipityHTTPPath'],
                   $_POST['indexFile']
                 ),

                 implode('', $a)
              );

    if ( !$fp ) {
        $errs[] = sprintf(FILE_WRITE_ERROR, '.htaccess') . ' ' . FILE_CREATE_YOURSELF;
        $errs[] = sprintf(COPY_CODE_BELOW , '.htaccess', 'serendipity', $content);
        return $errs;
    } else {
        fwrite($fp, $content);
        fclose($fp);
        return true;
    }

}

function serendipity_updateConfiguration() {
    global $serendipity, $umask;

    // Save all basic config variables to the database
    $p = serendipity_parseTemplate("./serendipity_config_local.tpl", true);

    foreach($p as $key => $entry) {
        serendipity_set_config_var($entry['name'], $_POST[$entry['name']]);
    }

    // Create a basic configuration file which gives enough information to open
    // the database and get information from the database tables
    $configfp = fopen('./serendipity_config_local.inc.php', 'w');

    if ( !is_resource($configfp) ) {
        $errs[] = sprintf(FILE_WRITE_ERROR, './serendipity_config_local.inc.php');
        $errs[] = sprintf(DIRECTORY_RUN_CMD, 'chown -R www:www', $_POST['serendipityPath']) . '(' . WWW_USER . ')';
        $errs[] = sprintf(DIRECTORY_RUN_CMD, 'chmod 770'       , $_POST['serendipityPath']);
        $errs[] = BROWSER_RELOAD;

        return $errs;
    }

    fwrite($configfp, "<?php\n");
    fwrite($configfp, "\t\$serendipity['versionInstalled']  = '{$serendipity['version']}';\n\n");
    fwrite($configfp, "\t\$serendipity['dbName']            = '{$_POST['dbName']}';\n");
    fwrite($configfp, "\t\$serendipity['dbPrefix']          = '{$_POST['dbPrefix']}';\n");
    fwrite($configfp, "\t\$serendipity['dbHost']            = '{$_POST['dbHost']}';\n");
    fwrite($configfp, "\t\$serendipity['dbUser']            = '{$_POST['dbUser']}';\n");
    fwrite($configfp, "\t\$serendipity['dbPass']            = '{$_POST['dbPass']}';\n");
    fwrite($configfp, "\t\$serendipity['dbType']            = '{$_POST['dbType']}';\n");
    fwrite($configfp, "?>\n");

    fclose($configfp);

    @chmod('./serendipity_config_local.inc.php', $umask);
    return true;

}

if (!isset($_POST['installAction'])) {
    $_POST['installAction'] = '';
}

switch ($_POST['installAction']) {
    case 'check':
        /* If we already have serendipity installed, all we need to do is write the configuration again */
        if (!defined('IN_serendipity') || IN_serendipity !== true) {
            $res = serendipity_checkInstallation();

            if (is_array($res)) {
                echo DIAGNOSTIC_ERROR . '<br /><br />';
                echo '<span style="color: #FF0000">- ' . implode('<br />', $res) . '</span><br /><br />';
                serendipity_printConfigTemplate(serendipity_parseTemplate('./serendipity_config_local.tpl'), $_POST);
                die();
            }

            echo '<br />';

            /* We are good to go, lets install databases etc. */
            echo ATTEMPT_SETUP_DATABASE . "<br />";
            $res = serendipity_installDatabase();
            if ( $res !== false ) {
                echo ' ' . DATABASE_DONE . '<br />';
            } else {
                echo '<span style="color: #FF0000">- ' . DATABASE_ALREADY_INSTALLED . '</span><br />';
            }

            /* Next are the files, .htaccess */
            printf(ATTEMPT_WRITE_FILE, '.htaccess');
            $res = serendipity_installFiles();
            if ( is_array($res) ) {
                echo '<span style="color: #FF0000">- ' . implode('<br />', $res) . '</span><br /><br />';
                die();
            } else {
                echo DONE . '<br />';
            }

            /* We are now installed */
            define('IN_serendipity', true);

            /* register default plugins */
            $GLOBALS['serendipity']['dbPrefix'] = $_POST['dbPrefix'];
            $GLOBALS['serendipity']['dbName']   = $_POST['dbName'];

            include_once 'serendipity_plugin_api.php';
            serendipity_plugin_api::register_default_plugins();

            printf(
              SERENDIPITY_INSTALLED . '<br />',

              '<p><strong>',
              '</strong></p>',

              $_POST['pass'],
              $_POST['user'],

              '<br /><br />',

              $_POST['serendipityHTTPPath']
            );

            session_destroy();

        }

        $res = serendipity_updateConfiguration();
        if ( is_array($res) ) {
            echo DIAGNOSTIC_ERROR;
            echo '<span style="color: #FF0000">- ' . implode('<br />', $res) . '</span><br /><br />';
        } else {
            echo WRITTEN_N_SAVED;
        }

        break;

    default:
        /*  Is serendipity already installed=  */
        if ( file_exists('./serendipity_config_local.inc.php') ) {
            $from = &$serendipity;
        } else {
            /* Do check for non-apache servers */
            if ( !eregi('apache', $_SERVER['SERVER_SOFTWARE']) ) {
                echo '<br /><font color="#FF000">WARNING!<br />You are about to attempt to install Serendipity on a non-apache webserver.<br />Serendipity requires the Apache Werbserver to function correctly!</font>';
            }

            define('VERSION_REQUIRED', '4.2.1');

            /* Do check for required PHP version */
            if ( version_compare(PHP_VERSION, VERSION_REQUIRED) == -1 ) {
                echo '<br /><font color="#FF0000">WARNING!<br />You are using PHP version '. PHP_VERSION .'! Serendipity requires version '. VERSION_REQUIRED .'</font>';
            }
            $from = false;
        }

        serendipity_printConfigTemplate(serendipity_parseTemplate('./serendipity_config_local.tpl'), $from);
}

/* vim: set sts=4 ts=4 expandtab : */
?>

